// services/webnn/public/mojom/webnn_buffer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_BUFFER_MOJOM_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_BUFFER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_buffer.mojom-features.h"
#include "services/webnn/public/mojom/webnn_buffer.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_buffer.mojom-forward.h"
#include "mojo/public/mojom/base/big_buffer.mojom.h"
#include "services/webnn/public/mojom/webnn_error.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace webnn::mojom {

class WebNNBufferProxy;

template <typename ImplRefTraits>
class WebNNBufferStub;

class WebNNBufferRequestValidator;
class WebNNBufferResponseValidator;


class WebNNBuffer
    : public WebNNBufferInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNBufferInterfaceBase;
  using Proxy_ = WebNNBufferProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNBufferStub<ImplRefTraits>;

  using RequestValidator_ = WebNNBufferRequestValidator;
  using ResponseValidator_ = WebNNBufferResponseValidator;
  enum MethodMinVersions : uint32_t {
    kReadBufferMinVersion = 0,
    kWriteBufferMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ReadBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct WriteBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNBuffer() = default;


  using ReadBufferCallback = base::OnceCallback<void(ReadBufferResultPtr)>;
  
  virtual void ReadBuffer(ReadBufferCallback callback) = 0;

  
  virtual void WriteBuffer(::mojo_base::BigBuffer src_buffer) = 0;
};



class  WebNNBufferProxy
    : public WebNNBuffer {
 public:
  using InterfaceType = WebNNBuffer;

  explicit WebNNBufferProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ReadBuffer(ReadBufferCallback callback) final;
  
  void WriteBuffer(::mojo_base::BigBuffer src_buffer) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebNNBufferStubDispatch {
 public:
  static bool Accept(WebNNBuffer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNBuffer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNBuffer>>
class WebNNBufferStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNBufferStub() = default;
  ~WebNNBufferStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNBufferStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNBufferStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNBufferRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNBufferResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  BufferInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BufferInfo, T>::value>;
  using DataView = BufferInfoDataView;
  using Data_ = internal::BufferInfo_Data;

  template <typename... Args>
  static BufferInfoPtr New(Args&&... args) {
    return BufferInfoPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BufferInfoPtr From(const U& u) {
    return mojo::TypeConverter<BufferInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BufferInfo>::Convert(*this);
  }


  BufferInfo();

  explicit BufferInfo(
      uint64_t size);


  ~BufferInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BufferInfoPtr>
  BufferInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BufferInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BufferInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BufferInfo_UnserializedMessageContext<
            UserType, BufferInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BufferInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BufferInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BufferInfo_UnserializedMessageContext<
            UserType, BufferInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BufferInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t size;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BufferInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ReadBufferResult {
 public:
  using DataView = ReadBufferResultDataView;
  using Data_ = internal::ReadBufferResult_Data;
  using Tag = Data_::ReadBufferResult_Tag;

  template <typename... Args>
  static ReadBufferResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |buffer|.
  static ReadBufferResultPtr
  NewBuffer(
      ::mojo_base::BigBuffer value) {
    auto result = ReadBufferResultPtr(std::in_place);
    result->set_buffer(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static ReadBufferResultPtr
  NewError(
      ::webnn::mojom::ErrorPtr value) {
    auto result = ReadBufferResultPtr(std::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static ReadBufferResultPtr From(const U& u) {
    return mojo::TypeConverter<ReadBufferResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ReadBufferResult>::Convert(*this);
  }

  ReadBufferResult();
  ~ReadBufferResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  ReadBufferResult(const ReadBufferResult& other) = delete;
  ReadBufferResult& operator=(const ReadBufferResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = ReadBufferResultPtr>
  ReadBufferResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ReadBufferResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, ReadBufferResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_buffer() const { return tag_ == Tag::kBuffer; }

  
  ::mojo_base::BigBuffer& get_buffer() const {
    CHECK(tag_ == Tag::kBuffer);
    return *(data_.buffer);
  }

  
  void set_buffer(
      ::mojo_base::BigBuffer buffer);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  ::webnn::mojom::ErrorPtr& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      ::webnn::mojom::ErrorPtr error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ReadBufferResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<ReadBufferResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::mojo_base::BigBuffer* buffer;
    ::webnn::mojom::ErrorPtr* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};


template <typename UnionPtrType>
ReadBufferResultPtr ReadBufferResult::Clone() const {
  switch (tag_) {
    case Tag::kBuffer:
      return NewBuffer(
          mojo::Clone(*data_.buffer));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ReadBufferResult>::value>::type*>
bool ReadBufferResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kBuffer:
      return mojo::Equals(*(data_.buffer), *(other.data_.buffer));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}
template <typename StructPtrType>
BufferInfoPtr BufferInfo::Clone() const {
  return New(
      mojo::Clone(size)
  );
}

template <typename T, BufferInfo::EnableIfSame<T>*>
bool BufferInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  return true;
}

template <typename T, BufferInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  return false;
}


}  // webnn::mojom

namespace mojo {


template <>
struct  StructTraits<::webnn::mojom::BufferInfo::DataView,
                                         ::webnn::mojom::BufferInfoPtr> {
  static bool IsNull(const ::webnn::mojom::BufferInfoPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::BufferInfoPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::BufferInfo::size) size(
      const ::webnn::mojom::BufferInfoPtr& input) {
    return input->size;
  }

  static bool Read(::webnn::mojom::BufferInfo::DataView input, ::webnn::mojom::BufferInfoPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::ReadBufferResult::DataView,
                                        ::webnn::mojom::ReadBufferResultPtr> {
  static bool IsNull(const ::webnn::mojom::ReadBufferResultPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::ReadBufferResultPtr* output) { output->reset(); }

  static ::webnn::mojom::ReadBufferResult::Tag GetTag(const ::webnn::mojom::ReadBufferResultPtr& input) {
    return input->which();
  }

  static  ::mojo_base::BigBuffer& buffer( ::webnn::mojom::ReadBufferResultPtr& input) {
    return input->get_buffer();
  }

  static const ::webnn::mojom::ErrorPtr& error(const ::webnn::mojom::ReadBufferResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::webnn::mojom::ReadBufferResult::DataView input, ::webnn::mojom::ReadBufferResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_BUFFER_MOJOM_H_