// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_check_visibility_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"checkOpacity",
"checkVisibilityCSS",
"contentVisibilityAuto",
"opacityProperty",
"visibilityProperty",
};


}  // namespace 

CheckVisibilityOptions* CheckVisibilityOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CheckVisibilityOptions* dictionary = MakeGarbageCollected<CheckVisibilityOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CheckVisibilityOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CheckVisibilityOptions::CheckVisibilityOptions() {
  
}

 CheckVisibilityOptions::CheckVisibilityOptions(v8::Isolate* isolate) {
  
}




























void CheckVisibilityOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_check_opacity_);
TraceIfNeeded<bool>::Trace(visitor, member_check_visibility_css_);
TraceIfNeeded<bool>::Trace(visitor, member_content_visibility_auto_);
TraceIfNeeded<bool>::Trace(visitor, member_opacity_property_);
TraceIfNeeded<bool>::Trace(visitor, member_visibility_property_);
bindings::DictionaryBase::Trace(visitor);
}

void CheckVisibilityOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CheckVisibilityOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCheckOpacity()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_check_opacity_);
DCHECK(!values[0].IsEmpty());
}
if (hasCheckVisibilityCSS()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_check_visibility_css_);
DCHECK(!values[1].IsEmpty());
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasContentVisibilityAuto()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_content_visibility_auto_);
DCHECK(!values[2].IsEmpty());
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasOpacityProperty()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_opacity_property_);
DCHECK(!values[3].IsEmpty());
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasVisibilityProperty()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_visibility_property_);
DCHECK(!values[4].IsEmpty());
}
}
}

const void* CheckVisibilityOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CheckVisibilityOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CheckVisibilityOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CheckVisibilityOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("checkOpacity");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_check_opacity_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("checkVisibilityCSS");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_check_visibility_css_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("contentVisibilityAuto");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_content_visibility_auto_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("opacityProperty");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_opacity_property_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("visibilityProperty");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_visibility_property_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> CheckVisibilityOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
