// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_dom_matrix_2d_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"a",
"b",
"c",
"d",
"e",
"f",
"m11",
"m12",
"m21",
"m22",
"m41",
"m42",
};


}  // namespace 

DOMMatrix2DInit* DOMMatrix2DInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DOMMatrix2DInit* dictionary = MakeGarbageCollected<DOMMatrix2DInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DOMMatrix2DInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DOMMatrix2DInit::DOMMatrix2DInit() {
  
}

 DOMMatrix2DInit::DOMMatrix2DInit(v8::Isolate* isolate) {
  
}























































































void DOMMatrix2DInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_a_);
TraceIfNeeded<double>::Trace(visitor, member_b_);
TraceIfNeeded<double>::Trace(visitor, member_c_);
TraceIfNeeded<double>::Trace(visitor, member_d_);
TraceIfNeeded<double>::Trace(visitor, member_e_);
TraceIfNeeded<double>::Trace(visitor, member_f_);
TraceIfNeeded<double>::Trace(visitor, member_m_11_);
TraceIfNeeded<double>::Trace(visitor, member_m_12_);
TraceIfNeeded<double>::Trace(visitor, member_m_21_);
TraceIfNeeded<double>::Trace(visitor, member_m_22_);
TraceIfNeeded<double>::Trace(visitor, member_m_41_);
TraceIfNeeded<double>::Trace(visitor, member_m_42_);
bindings::DictionaryBase::Trace(visitor);
}

void DOMMatrix2DInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void DOMMatrix2DInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasA()) {
  values[0] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_a_);
DCHECK(!values[0].IsEmpty());
}
if (hasB()) {
  values[1] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_b_);
DCHECK(!values[1].IsEmpty());
}
if (hasC()) {
  values[2] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_c_);
DCHECK(!values[2].IsEmpty());
}
if (hasD()) {
  values[3] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_d_);
DCHECK(!values[3].IsEmpty());
}
if (hasE()) {
  values[4] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_e_);
DCHECK(!values[4].IsEmpty());
}
if (hasF()) {
  values[5] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_f_);
DCHECK(!values[5].IsEmpty());
}
if (hasM11()) {
  values[6] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_11_);
DCHECK(!values[6].IsEmpty());
}
if (hasM12()) {
  values[7] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_12_);
DCHECK(!values[7].IsEmpty());
}
if (hasM21()) {
  values[8] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_21_);
DCHECK(!values[8].IsEmpty());
}
if (hasM22()) {
  values[9] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_22_);
DCHECK(!values[9].IsEmpty());
}
if (hasM41()) {
  values[10] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_41_);
DCHECK(!values[10].IsEmpty());
}
if (hasM42()) {
  values[11] = ToV8Traits<IDLUnrestrictedDouble>::ToV8(script_state, member_m_42_);
DCHECK(!values[11].IsEmpty());
}
}

const void* DOMMatrix2DInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> DOMMatrix2DInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void DOMMatrix2DInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DOMMatrix2DInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("a");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_a_, member_a_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("b");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_b_, member_b_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("c");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_c_, member_c_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("d");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_d_, member_d_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("e");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_e_, member_e_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("f");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_f_, member_f_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m11");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_m_11_, member_m_11_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m12");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_m_12_, member_m_12_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m21");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_m_21_, member_m_21_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m22");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_m_22_, member_m_22_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m41");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_m_41_, member_m_41_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m42");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_m_42_, member_m_42_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DOMMatrix2DInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
