// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_dom_quad_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_dom_point_init.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"p1",
"p2",
"p3",
"p4",
};


}  // namespace 

DOMQuadInit* DOMQuadInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DOMQuadInit* dictionary = MakeGarbageCollected<DOMQuadInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DOMQuadInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DOMQuadInit::DOMQuadInit() {
  
}

 DOMQuadInit::DOMQuadInit(v8::Isolate* isolate) {
  
}































void DOMQuadInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DOMPointInit>>::Trace(visitor, member_p_1_);
TraceIfNeeded<Member<DOMPointInit>>::Trace(visitor, member_p_2_);
TraceIfNeeded<Member<DOMPointInit>>::Trace(visitor, member_p_3_);
TraceIfNeeded<Member<DOMPointInit>>::Trace(visitor, member_p_4_);
bindings::DictionaryBase::Trace(visitor);
}

void DOMQuadInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void DOMQuadInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasP1()) {
  values[0] = ToV8Traits<DOMPointInit>::ToV8(script_state, member_p_1_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasP2()) {
  values[1] = ToV8Traits<DOMPointInit>::ToV8(script_state, member_p_2_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasP3()) {
  values[2] = ToV8Traits<DOMPointInit>::ToV8(script_state, member_p_3_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasP4()) {
  values[3] = ToV8Traits<DOMPointInit>::ToV8(script_state, member_p_4_.Get());
DCHECK(!values[3].IsEmpty());
}
}

const void* DOMQuadInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> DOMQuadInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void DOMQuadInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DOMQuadInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("p1");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<DOMPointInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_p_1_, member_p_1_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("p2");
if (!bindings::GetDictionaryMemberFromV8Object<DOMPointInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_p_2_, member_p_2_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("p3");
if (!bindings::GetDictionaryMemberFromV8Object<DOMPointInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_p_3_, member_p_3_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("p4");
if (!bindings::GetDictionaryMemberFromV8Object<DOMPointInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_p_4_, member_p_4_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DOMQuadInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
