// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_response_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_bytestringbytestringrecord_bytestringsequencesequence.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"headers",
"status",
"statusText",
};


}  // namespace 

ResponseInit* ResponseInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ResponseInit* dictionary = MakeGarbageCollected<ResponseInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ResponseInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ResponseInit::ResponseInit() {
  
}

 ResponseInit::ResponseInit(v8::Isolate* isolate) {
  
}















void ResponseInit::setStatusText(const String& value) {
  member_status_text_ = value;
}

void ResponseInit::setStatusText(String&& value) {
  member_status_text_ = std::move(value);
}




void ResponseInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionByteStringByteStringRecordOrByteStringSequenceSequence>>::Trace(visitor, member_headers_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_status_);
TraceIfNeeded<String>::Trace(visitor, member_status_text_);
bindings::DictionaryBase::Trace(visitor);
}

void ResponseInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void ResponseInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasHeaders()) {
  values[0] = ToV8Traits<V8UnionByteStringByteStringRecordOrByteStringSequenceSequence>::ToV8(script_state, member_headers_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasStatus()) {
  values[1] = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_status_);
DCHECK(!values[1].IsEmpty());
}
if (hasStatusText()) {
  values[2] = ToV8Traits<IDLByteString>::ToV8(script_state, member_status_text_);
DCHECK(!values[2].IsEmpty());
}
}

const void* ResponseInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> ResponseInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void ResponseInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ResponseInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("headers");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionByteStringByteStringRecordOrByteStringSequenceSequence, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_headers_, member_headers_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("status");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_status_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("statusText");
if (!bindings::GetDictionaryMemberFromV8Object<IDLByteString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_status_text_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ResponseInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
