// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_shadow_root_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/html/custom/custom_element_registry.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clonable",
"delegatesFocus",
"mode",
"registry",
"serializable",
"slotAssignment",
};


}  // namespace 

ShadowRootInit* ShadowRootInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ShadowRootInit* dictionary = MakeGarbageCollected<ShadowRootInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ShadowRootInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ShadowRootInit::ShadowRootInit() {
  
}

 ShadowRootInit::ShadowRootInit(v8::Isolate* isolate) {
  
}











































void ShadowRootInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_clonable_);
TraceIfNeeded<bool>::Trace(visitor, member_delegates_focus_);
TraceIfNeeded<V8ShadowRootMode>::Trace(visitor, member_mode_);
TraceIfNeeded<Member<CustomElementRegistry>>::Trace(visitor, member_registry_);
TraceIfNeeded<bool>::Trace(visitor, member_serializable_);
TraceIfNeeded<V8SlotAssignmentMode>::Trace(visitor, member_slot_assignment_);
bindings::DictionaryBase::Trace(visitor);
}

void ShadowRootInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void ShadowRootInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (RuntimeEnabledFeatures::ShadowRootClonableEnabled()) {
  if (hasClonable()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_clonable_);
DCHECK(!values[0].IsEmpty());
}
}
if (hasDelegatesFocus()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_delegates_focus_);
DCHECK(!values[1].IsEmpty());
}
if (hasMode()) {
  values[2] = ToV8Traits<V8ShadowRootMode>::ToV8(script_state, member_mode_);
DCHECK(!values[2].IsEmpty());
}
if (RuntimeEnabledFeatures::ScopedCustomElementRegistryEnabled()) {
  if (hasRegistry()) {
  values[3] = ToV8Traits<CustomElementRegistry>::ToV8(script_state, member_registry_.Get());
DCHECK(!values[3].IsEmpty());
}
}
if (RuntimeEnabledFeatures::ElementGetHTMLEnabled()) {
  if (hasSerializable()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_serializable_);
DCHECK(!values[4].IsEmpty());
}
}
if (hasSlotAssignment()) {
  values[5] = ToV8Traits<V8SlotAssignmentMode>::ToV8(script_state, member_slot_assignment_);
DCHECK(!values[5].IsEmpty());
}
}

const void* ShadowRootInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> ShadowRootInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void ShadowRootInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ShadowRootInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::ShadowRootClonableEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("clonable");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_clonable_, member_clonable_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("delegatesFocus");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_delegates_focus_, member_delegates_focus_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8ShadowRootMode, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mode_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::ScopedCustomElementRegistryEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("registry");
if (!bindings::GetDictionaryMemberFromV8Object<CustomElementRegistry, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_registry_, member_registry_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::ElementGetHTMLEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("serializable");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_serializable_, member_serializable_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("slotAssignment");
if (!bindings::GetDictionaryMemberFromV8Object<V8SlotAssignmentMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_slot_assignment_, member_slot_assignment_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ShadowRootInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
