// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_touch_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/dom/events/event_target.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clientX",
"clientY",
"force",
"identifier",
"pageX",
"pageY",
"radiusX",
"radiusY",
"region",
"rotationAngle",
"screenX",
"screenY",
"target",
};


}  // namespace 

TouchInit* TouchInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  TouchInit* dictionary = MakeGarbageCollected<TouchInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "TouchInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 TouchInit::TouchInit() {
  
}

 TouchInit::TouchInit(v8::Isolate* isolate) {
  
}











































void TouchInit::setRegion(const String& value) {
  member_region_ = value;
}

void TouchInit::setRegion(String&& value) {
  member_region_ = std::move(value);
}
























void TouchInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_client_x_);
TraceIfNeeded<double>::Trace(visitor, member_client_y_);
TraceIfNeeded<float>::Trace(visitor, member_force_);
TraceIfNeeded<int32_t>::Trace(visitor, member_identifier_);
TraceIfNeeded<double>::Trace(visitor, member_page_x_);
TraceIfNeeded<double>::Trace(visitor, member_page_y_);
TraceIfNeeded<float>::Trace(visitor, member_radius_x_);
TraceIfNeeded<float>::Trace(visitor, member_radius_y_);
TraceIfNeeded<String>::Trace(visitor, member_region_);
TraceIfNeeded<float>::Trace(visitor, member_rotation_angle_);
TraceIfNeeded<double>::Trace(visitor, member_screen_x_);
TraceIfNeeded<double>::Trace(visitor, member_screen_y_);
TraceIfNeeded<Member<EventTarget>>::Trace(visitor, member_target_);
bindings::DictionaryBase::Trace(visitor);
}

void TouchInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void TouchInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasClientX()) {
  values[0] = ToV8Traits<IDLDouble>::ToV8(script_state, member_client_x_);
DCHECK(!values[0].IsEmpty());
}
if (hasClientY()) {
  values[1] = ToV8Traits<IDLDouble>::ToV8(script_state, member_client_y_);
DCHECK(!values[1].IsEmpty());
}
if (hasForce()) {
  values[2] = ToV8Traits<IDLFloat>::ToV8(script_state, member_force_);
DCHECK(!values[2].IsEmpty());
}
if (hasIdentifier()) {
  values[3] = ToV8Traits<IDLLong>::ToV8(script_state, member_identifier_);
DCHECK(!values[3].IsEmpty());
}
if (hasPageX()) {
  values[4] = ToV8Traits<IDLDouble>::ToV8(script_state, member_page_x_);
DCHECK(!values[4].IsEmpty());
}
if (hasPageY()) {
  values[5] = ToV8Traits<IDLDouble>::ToV8(script_state, member_page_y_);
DCHECK(!values[5].IsEmpty());
}
if (hasRadiusX()) {
  values[6] = ToV8Traits<IDLFloat>::ToV8(script_state, member_radius_x_);
DCHECK(!values[6].IsEmpty());
}
if (hasRadiusY()) {
  values[7] = ToV8Traits<IDLFloat>::ToV8(script_state, member_radius_y_);
DCHECK(!values[7].IsEmpty());
}
if (hasRegion()) {
  values[8] = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_region_);
DCHECK(!values[8].IsEmpty());
}
if (hasRotationAngle()) {
  values[9] = ToV8Traits<IDLFloat>::ToV8(script_state, member_rotation_angle_);
DCHECK(!values[9].IsEmpty());
}
if (hasScreenX()) {
  values[10] = ToV8Traits<IDLDouble>::ToV8(script_state, member_screen_x_);
DCHECK(!values[10].IsEmpty());
}
if (hasScreenY()) {
  values[11] = ToV8Traits<IDLDouble>::ToV8(script_state, member_screen_y_);
DCHECK(!values[11].IsEmpty());
}
if (hasTarget()) {
  values[12] = ToV8Traits<EventTarget>::ToV8(script_state, member_target_.Get());
DCHECK(!values[12].IsEmpty());
}
}

const void* TouchInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> TouchInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void TouchInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "TouchInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientX");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_client_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_client_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("force");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_force_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("identifier");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_identifier_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pageX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_page_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pageY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_page_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("radiusX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_radius_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("radiusY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_radius_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("region");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_region_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rotationAngle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_rotation_angle_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("screenX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_screen_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("screenY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_screen_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("target");
if (!bindings::GetDictionaryMemberFromV8Object<EventTarget, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_target_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> TouchInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
