// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_validity_state_flags.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"badInput",
"customError",
"patternMismatch",
"rangeOverflow",
"rangeUnderflow",
"stepMismatch",
"tooLong",
"tooShort",
"typeMismatch",
"valueMissing",
};


}  // namespace 

ValidityStateFlags* ValidityStateFlags::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ValidityStateFlags* dictionary = MakeGarbageCollected<ValidityStateFlags>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ValidityStateFlags";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ValidityStateFlags::ValidityStateFlags() {
  
}

 ValidityStateFlags::ValidityStateFlags(v8::Isolate* isolate) {
  
}





















































void ValidityStateFlags::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_bad_input_);
TraceIfNeeded<bool>::Trace(visitor, member_custom_error_);
TraceIfNeeded<bool>::Trace(visitor, member_pattern_mismatch_);
TraceIfNeeded<bool>::Trace(visitor, member_range_overflow_);
TraceIfNeeded<bool>::Trace(visitor, member_range_underflow_);
TraceIfNeeded<bool>::Trace(visitor, member_step_mismatch_);
TraceIfNeeded<bool>::Trace(visitor, member_too_long_);
TraceIfNeeded<bool>::Trace(visitor, member_too_short_);
TraceIfNeeded<bool>::Trace(visitor, member_type_mismatch_);
TraceIfNeeded<bool>::Trace(visitor, member_value_missing_);
bindings::DictionaryBase::Trace(visitor);
}

void ValidityStateFlags::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void ValidityStateFlags::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasBadInput()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_bad_input_);
DCHECK(!values[0].IsEmpty());
}
if (hasCustomError()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_custom_error_);
DCHECK(!values[1].IsEmpty());
}
if (hasPatternMismatch()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_pattern_mismatch_);
DCHECK(!values[2].IsEmpty());
}
if (hasRangeOverflow()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_range_overflow_);
DCHECK(!values[3].IsEmpty());
}
if (hasRangeUnderflow()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_range_underflow_);
DCHECK(!values[4].IsEmpty());
}
if (hasStepMismatch()) {
  values[5] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_step_mismatch_);
DCHECK(!values[5].IsEmpty());
}
if (hasTooLong()) {
  values[6] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_too_long_);
DCHECK(!values[6].IsEmpty());
}
if (hasTooShort()) {
  values[7] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_too_short_);
DCHECK(!values[7].IsEmpty());
}
if (hasTypeMismatch()) {
  values[8] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_type_mismatch_);
DCHECK(!values[8].IsEmpty());
}
if (hasValueMissing()) {
  values[9] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_value_missing_);
DCHECK(!values[9].IsEmpty());
}
}

const void* ValidityStateFlags::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> ValidityStateFlags::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void ValidityStateFlags::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ValidityStateFlags";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("badInput");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_bad_input_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("customError");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_custom_error_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("patternMismatch");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_pattern_mismatch_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeOverflow");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_range_overflow_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeUnderflow");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_range_underflow_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stepMismatch");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_step_mismatch_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tooLong");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_too_long_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tooShort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_too_short_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("typeMismatch");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_type_mismatch_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("valueMissing");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_value_missing_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ValidityStateFlags::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
