// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_cookie_store_delete_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"domain",
"name",
"partitioned",
"path",
};


}  // namespace 

CookieStoreDeleteOptions* CookieStoreDeleteOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CookieStoreDeleteOptions* dictionary = MakeGarbageCollected<CookieStoreDeleteOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CookieStoreDeleteOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CookieStoreDeleteOptions::CookieStoreDeleteOptions() {
  
}

 CookieStoreDeleteOptions::CookieStoreDeleteOptions(v8::Isolate* isolate) {
  
}



void CookieStoreDeleteOptions::setDomain(const String& value) {
  member_domain_ = value;
}

void CookieStoreDeleteOptions::setDomain(String&& value) {
  member_domain_ = std::move(value);
}




void CookieStoreDeleteOptions::setName(const String& value) {
  member_name_ = value;
}

void CookieStoreDeleteOptions::setName(String&& value) {
  member_name_ = std::move(value);
}









void CookieStoreDeleteOptions::setPath(const String& value) {
  member_path_ = value;
}

void CookieStoreDeleteOptions::setPath(String&& value) {
  member_path_ = std::move(value);
}




void CookieStoreDeleteOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_domain_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
TraceIfNeeded<bool>::Trace(visitor, member_partitioned_);
TraceIfNeeded<String>::Trace(visitor, member_path_);
bindings::DictionaryBase::Trace(visitor);
}

void CookieStoreDeleteOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CookieStoreDeleteOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDomain()) {
  values[0] = ToV8Traits<IDLNullable<IDLUSVString>>::ToV8(script_state, member_domain_);
DCHECK(!values[0].IsEmpty());
}
if (hasName()) {
  values[1] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_name_);
DCHECK(!values[1].IsEmpty());
}
if (hasPartitioned()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_partitioned_);
DCHECK(!values[2].IsEmpty());
}
if (hasPath()) {
  values[3] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_path_);
DCHECK(!values[3].IsEmpty());
}
}

const void* CookieStoreDeleteOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CookieStoreDeleteOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CookieStoreDeleteOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CookieStoreDeleteOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("domain");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_domain_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("partitioned");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_partitioned_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("path");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_path_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CookieStoreDeleteOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
