// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_credential_creation_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_federated_credential_init.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_password_credential_data.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_creation_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_htmlformelement_passwordcredentialdata.h"
#include "third_party/blink/renderer/core/dom/abort_signal.h"
#include "third_party/blink/renderer/core/html/forms/html_form_element.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"federated",
"password",
"publicKey",
"signal",
};


}  // namespace 

CredentialCreationOptions* CredentialCreationOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CredentialCreationOptions* dictionary = MakeGarbageCollected<CredentialCreationOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CredentialCreationOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CredentialCreationOptions::CredentialCreationOptions() {
  
}

 CredentialCreationOptions::CredentialCreationOptions(v8::Isolate* isolate) {
  
}































void CredentialCreationOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<FederatedCredentialInit>>::Trace(visitor, member_federated_);
TraceIfNeeded<Member<V8UnionHTMLFormElementOrPasswordCredentialData>>::Trace(visitor, member_password_);
TraceIfNeeded<Member<PublicKeyCredentialCreationOptions>>::Trace(visitor, member_public_key_);
TraceIfNeeded<Member<AbortSignal>>::Trace(visitor, member_signal_);
bindings::DictionaryBase::Trace(visitor);
}

void CredentialCreationOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void CredentialCreationOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasFederated()) {
  values[0] = ToV8Traits<FederatedCredentialInit>::ToV8(script_state, member_federated_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasPassword()) {
  values[1] = ToV8Traits<V8UnionHTMLFormElementOrPasswordCredentialData>::ToV8(script_state, member_password_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasPublicKey()) {
  values[2] = ToV8Traits<PublicKeyCredentialCreationOptions>::ToV8(script_state, member_public_key_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasSignal()) {
  values[3] = ToV8Traits<AbortSignal>::ToV8(script_state, member_signal_.Get());
DCHECK(!values[3].IsEmpty());
}
}

const void* CredentialCreationOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> CredentialCreationOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void CredentialCreationOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CredentialCreationOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("federated");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<FederatedCredentialInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_federated_, member_federated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("password");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionHTMLFormElementOrPasswordCredentialData, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_password_, member_password_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("publicKey");
if (!bindings::GetDictionaryMemberFromV8Object<PublicKeyCredentialCreationOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_public_key_, member_public_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signal");
if (!bindings::GetDictionaryMemberFromV8Object<AbortSignal, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_signal_, member_signal_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CredentialCreationOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
