// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_batch_normalization_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_activation.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_operand.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"activation",
"axis",
"bias",
"epsilon",
"scale",
};


}  // namespace 

MLBatchNormalizationOptions* MLBatchNormalizationOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLBatchNormalizationOptions* dictionary = MakeGarbageCollected<MLBatchNormalizationOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLBatchNormalizationOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLBatchNormalizationOptions::MLBatchNormalizationOptions() {
  
}

 MLBatchNormalizationOptions::MLBatchNormalizationOptions(v8::Isolate* isolate) {
  
}


































void MLBatchNormalizationOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MLActivation>>::Trace(visitor, member_activation_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_axis_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_bias_);
TraceIfNeeded<float>::Trace(visitor, member_epsilon_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_scale_);
bindings::DictionaryBase::Trace(visitor);
}

void MLBatchNormalizationOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLBatchNormalizationOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasActivation()) {
  values[0] = ToV8Traits<MLActivation>::ToV8(script_state, member_activation_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasAxis()) {
  values[1] = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_axis_);
DCHECK(!values[1].IsEmpty());
}
if (hasBias()) {
  values[2] = ToV8Traits<MLOperand>::ToV8(script_state, member_bias_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasEpsilon()) {
  values[3] = ToV8Traits<IDLFloat>::ToV8(script_state, member_epsilon_);
DCHECK(!values[3].IsEmpty());
}
if (hasScale()) {
  values[4] = ToV8Traits<MLOperand>::ToV8(script_state, member_scale_.Get());
DCHECK(!values[4].IsEmpty());
}
}

const void* MLBatchNormalizationOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLBatchNormalizationOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLBatchNormalizationOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLBatchNormalizationOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("activation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MLActivation, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_activation_, member_activation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("axis");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_axis_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_bias_, member_bias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("epsilon");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_epsilon_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scale");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_scale_, member_scale_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLBatchNormalizationOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
