// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_context_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"devicePreference",
"deviceType",
"modelFormat",
"numThreads",
"powerPreference",
};


}  // namespace 

MLContextOptions* MLContextOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLContextOptions* dictionary = MakeGarbageCollected<MLContextOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLContextOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLContextOptions::MLContextOptions() {
  
}

 MLContextOptions::MLContextOptions(v8::Isolate* isolate) {
  
}




























void MLContextOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8MLDevicePreference>::Trace(visitor, member_device_preference_);
TraceIfNeeded<V8MLDeviceType>::Trace(visitor, member_device_type_);
TraceIfNeeded<V8MLModelFormat>::Trace(visitor, member_model_format_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_num_threads_);
TraceIfNeeded<V8MLPowerPreference>::Trace(visitor, member_power_preference_);
bindings::DictionaryBase::Trace(visitor);
}

void MLContextOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLContextOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasDevicePreference()) {
  values[0] = ToV8Traits<V8MLDevicePreference>::ToV8(script_state, member_device_preference_);
DCHECK(!values[0].IsEmpty());
}
if (hasDeviceType()) {
  values[1] = ToV8Traits<V8MLDeviceType>::ToV8(script_state, member_device_type_);
DCHECK(!values[1].IsEmpty());
}
if (hasModelFormat()) {
  values[2] = ToV8Traits<V8MLModelFormat>::ToV8(script_state, member_model_format_);
DCHECK(!values[2].IsEmpty());
}
if (hasNumThreads()) {
  values[3] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_num_threads_);
DCHECK(!values[3].IsEmpty());
}
if (hasPowerPreference()) {
  values[4] = ToV8Traits<V8MLPowerPreference>::ToV8(script_state, member_power_preference_);
DCHECK(!values[4].IsEmpty());
}
}

const void* MLContextOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLContextOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLContextOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLContextOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("devicePreference");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8MLDevicePreference, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_device_preference_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("deviceType");
if (!bindings::GetDictionaryMemberFromV8Object<V8MLDeviceType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_device_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("modelFormat");
if (!bindings::GetDictionaryMemberFromV8Object<V8MLModelFormat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_model_format_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("numThreads");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_num_threads_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("powerPreference");
if (!bindings::GetDictionaryMemberFromV8Object<V8MLPowerPreference, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_power_preference_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLContextOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
