// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_conv_transpose_2d_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_activation.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_operand.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"activation",
"bias",
"dilations",
"filterLayout",
"groups",
"inputLayout",
"outputPadding",
"outputSizes",
"padding",
"strides",
};


}  // namespace 

MLConvTranspose2dOptions* MLConvTranspose2dOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLConvTranspose2dOptions* dictionary = MakeGarbageCollected<MLConvTranspose2dOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLConvTranspose2dOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLConvTranspose2dOptions::MLConvTranspose2dOptions() {
  
}

 MLConvTranspose2dOptions::MLConvTranspose2dOptions(v8::Isolate* isolate) {
  
}

















Vector<uint32_t> MLConvTranspose2dOptions::getDilationsOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasDilations()) {
  return fallback_value;
}
return member_dilations_;
}

Vector<uint32_t> MLConvTranspose2dOptions::getDilationsOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasDilations()) {
  return std::move(fallback_value);
}
return member_dilations_;
}

void MLConvTranspose2dOptions::setDilations(const Vector<uint32_t>& value) {
  member_dilations_ = value;
has_dilations_ = true;
}

void MLConvTranspose2dOptions::setDilations(Vector<uint32_t>&& value) {
  member_dilations_ = std::move(value);
has_dilations_ = true;
}



















Vector<uint32_t> MLConvTranspose2dOptions::getOutputPaddingOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasOutputPadding()) {
  return fallback_value;
}
return member_output_padding_;
}

Vector<uint32_t> MLConvTranspose2dOptions::getOutputPaddingOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasOutputPadding()) {
  return std::move(fallback_value);
}
return member_output_padding_;
}

void MLConvTranspose2dOptions::setOutputPadding(const Vector<uint32_t>& value) {
  member_output_padding_ = value;
has_output_padding_ = true;
}

void MLConvTranspose2dOptions::setOutputPadding(Vector<uint32_t>&& value) {
  member_output_padding_ = std::move(value);
has_output_padding_ = true;
}




Vector<uint32_t> MLConvTranspose2dOptions::getOutputSizesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasOutputSizes()) {
  return fallback_value;
}
return member_output_sizes_;
}

Vector<uint32_t> MLConvTranspose2dOptions::getOutputSizesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasOutputSizes()) {
  return std::move(fallback_value);
}
return member_output_sizes_;
}

void MLConvTranspose2dOptions::setOutputSizes(const Vector<uint32_t>& value) {
  member_output_sizes_ = value;
has_output_sizes_ = true;
}

void MLConvTranspose2dOptions::setOutputSizes(Vector<uint32_t>&& value) {
  member_output_sizes_ = std::move(value);
has_output_sizes_ = true;
}




Vector<uint32_t> MLConvTranspose2dOptions::getPaddingOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasPadding()) {
  return fallback_value;
}
return member_padding_;
}

Vector<uint32_t> MLConvTranspose2dOptions::getPaddingOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasPadding()) {
  return std::move(fallback_value);
}
return member_padding_;
}

void MLConvTranspose2dOptions::setPadding(const Vector<uint32_t>& value) {
  member_padding_ = value;
has_padding_ = true;
}

void MLConvTranspose2dOptions::setPadding(Vector<uint32_t>&& value) {
  member_padding_ = std::move(value);
has_padding_ = true;
}




Vector<uint32_t> MLConvTranspose2dOptions::getStridesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasStrides()) {
  return fallback_value;
}
return member_strides_;
}

Vector<uint32_t> MLConvTranspose2dOptions::getStridesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasStrides()) {
  return std::move(fallback_value);
}
return member_strides_;
}

void MLConvTranspose2dOptions::setStrides(const Vector<uint32_t>& value) {
  member_strides_ = value;
has_strides_ = true;
}

void MLConvTranspose2dOptions::setStrides(Vector<uint32_t>&& value) {
  member_strides_ = std::move(value);
has_strides_ = true;
}




void MLConvTranspose2dOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MLActivation>>::Trace(visitor, member_activation_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_bias_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_dilations_);
TraceIfNeeded<V8MLConvTranspose2dFilterOperandLayout>::Trace(visitor, member_filter_layout_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_groups_);
TraceIfNeeded<V8MLInputOperandLayout>::Trace(visitor, member_input_layout_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_output_padding_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_output_sizes_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_padding_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_strides_);
bindings::DictionaryBase::Trace(visitor);
}

void MLConvTranspose2dOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLConvTranspose2dOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasActivation()) {
  values[0] = ToV8Traits<MLActivation>::ToV8(script_state, member_activation_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasBias()) {
  values[1] = ToV8Traits<MLOperand>::ToV8(script_state, member_bias_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasDilations()) {
  values[2] = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_dilations_);
DCHECK(!values[2].IsEmpty());
}
if (hasFilterLayout()) {
  values[3] = ToV8Traits<V8MLConvTranspose2dFilterOperandLayout>::ToV8(script_state, member_filter_layout_);
DCHECK(!values[3].IsEmpty());
}
if (hasGroups()) {
  values[4] = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_groups_);
DCHECK(!values[4].IsEmpty());
}
if (hasInputLayout()) {
  values[5] = ToV8Traits<V8MLInputOperandLayout>::ToV8(script_state, member_input_layout_);
DCHECK(!values[5].IsEmpty());
}
if (hasOutputPadding()) {
  values[6] = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_output_padding_);
DCHECK(!values[6].IsEmpty());
}
if (hasOutputSizes()) {
  values[7] = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_output_sizes_);
DCHECK(!values[7].IsEmpty());
}
if (hasPadding()) {
  values[8] = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_padding_);
DCHECK(!values[8].IsEmpty());
}
if (hasStrides()) {
  values[9] = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_strides_);
DCHECK(!values[9].IsEmpty());
}
}

const void* MLConvTranspose2dOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLConvTranspose2dOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLConvTranspose2dOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLConvTranspose2dOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("activation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MLActivation, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_activation_, member_activation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bias_, member_bias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dilations");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_dilations_, member_dilations_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filterLayout");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8MLConvTranspose2dFilterOperandLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_filter_layout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("groups");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_groups_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inputLayout");
if (!bindings::GetDictionaryMemberFromV8Object<V8MLInputOperandLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_input_layout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("outputPadding");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_output_padding_, member_output_padding_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("outputSizes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_output_sizes_, member_output_sizes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("padding");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_padding_, member_padding_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("strides");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_strides_, member_strides_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLConvTranspose2dOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
