// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_storage_access_types.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"BroadcastChannel",
"SharedWorker",
"all",
"caches",
"cookies",
"createObjectURL",
"estimate",
"getDirectory",
"indexedDB",
"localStorage",
"locks",
"revokeObjectURL",
"sessionStorage",
};


}  // namespace 

StorageAccessTypes* StorageAccessTypes::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  StorageAccessTypes* dictionary = MakeGarbageCollected<StorageAccessTypes>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "StorageAccessTypes";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 StorageAccessTypes::StorageAccessTypes() {
  
}

 StorageAccessTypes::StorageAccessTypes(v8::Isolate* isolate) {
  
}




































































void StorageAccessTypes::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_broadcast_channel_);
TraceIfNeeded<bool>::Trace(visitor, member_shared_worker_);
TraceIfNeeded<bool>::Trace(visitor, member_all_);
TraceIfNeeded<bool>::Trace(visitor, member_caches_);
TraceIfNeeded<bool>::Trace(visitor, member_cookies_);
TraceIfNeeded<bool>::Trace(visitor, member_create_object_url_);
TraceIfNeeded<bool>::Trace(visitor, member_estimate_);
TraceIfNeeded<bool>::Trace(visitor, member_get_directory_);
TraceIfNeeded<bool>::Trace(visitor, member_indexed_db_);
TraceIfNeeded<bool>::Trace(visitor, member_local_storage_);
TraceIfNeeded<bool>::Trace(visitor, member_locks_);
TraceIfNeeded<bool>::Trace(visitor, member_revoke_object_url_);
TraceIfNeeded<bool>::Trace(visitor, member_session_storage_);
bindings::DictionaryBase::Trace(visitor);
}

void StorageAccessTypes::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void StorageAccessTypes::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasBroadcastChannel()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_broadcast_channel_);
DCHECK(!values[0].IsEmpty());
}
if (hasSharedWorker()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_shared_worker_);
DCHECK(!values[1].IsEmpty());
}
if (hasAll()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_all_);
DCHECK(!values[2].IsEmpty());
}
if (hasCaches()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_caches_);
DCHECK(!values[3].IsEmpty());
}
if (hasCookies()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_cookies_);
DCHECK(!values[4].IsEmpty());
}
if (hasCreateObjectURL()) {
  values[5] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_create_object_url_);
DCHECK(!values[5].IsEmpty());
}
if (hasEstimate()) {
  values[6] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_estimate_);
DCHECK(!values[6].IsEmpty());
}
if (hasGetDirectory()) {
  values[7] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_get_directory_);
DCHECK(!values[7].IsEmpty());
}
if (hasIndexedDB()) {
  values[8] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_indexed_db_);
DCHECK(!values[8].IsEmpty());
}
if (hasLocalStorage()) {
  values[9] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_local_storage_);
DCHECK(!values[9].IsEmpty());
}
if (hasLocks()) {
  values[10] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_locks_);
DCHECK(!values[10].IsEmpty());
}
if (hasRevokeObjectURL()) {
  values[11] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_revoke_object_url_);
DCHECK(!values[11].IsEmpty());
}
if (hasSessionStorage()) {
  values[12] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_session_storage_);
DCHECK(!values[12].IsEmpty());
}
}

const void* StorageAccessTypes::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> StorageAccessTypes::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void StorageAccessTypes::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "StorageAccessTypes";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("BroadcastChannel");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_broadcast_channel_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("SharedWorker");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_shared_worker_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("all");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_all_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("caches");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_caches_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("cookies");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_cookies_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("createObjectURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_create_object_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("estimate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_estimate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("getDirectory");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_get_directory_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("indexedDB");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_indexed_db_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("localStorage");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_local_storage_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("locks");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_locks_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("revokeObjectURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_revoke_object_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sessionStorage");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_session_storage_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> StorageAccessTypes::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
