// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_device_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_device_filter.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"exclusionFilters",
"filters",
};


}  // namespace 

USBDeviceRequestOptions* USBDeviceRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  USBDeviceRequestOptions* dictionary = MakeGarbageCollected<USBDeviceRequestOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "USBDeviceRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 USBDeviceRequestOptions::USBDeviceRequestOptions() {
  
}

 USBDeviceRequestOptions::USBDeviceRequestOptions(v8::Isolate* isolate) {
  
}



void USBDeviceRequestOptions::setExclusionFilters(const HeapVector<Member<USBDeviceFilter>>& value) {
  member_exclusion_filters_ = value;
}

void USBDeviceRequestOptions::setExclusionFilters(HeapVector<Member<USBDeviceFilter>>&& value) {
  member_exclusion_filters_ = std::move(value);
}




void USBDeviceRequestOptions::setFilters(const HeapVector<Member<USBDeviceFilter>>& value) {
  member_filters_ = value;
}

void USBDeviceRequestOptions::setFilters(HeapVector<Member<USBDeviceFilter>>&& value) {
  member_filters_ = std::move(value);
}




void USBDeviceRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<USBDeviceFilter>>>::Trace(visitor, member_exclusion_filters_);
TraceIfNeeded<HeapVector<Member<USBDeviceFilter>>>::Trace(visitor, member_filters_);
bindings::DictionaryBase::Trace(visitor);
}

void USBDeviceRequestOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void USBDeviceRequestOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasExclusionFilters()) {
  values[0] = ToV8Traits<IDLSequence<USBDeviceFilter>>::ToV8(script_state, member_exclusion_filters_);
DCHECK(!values[0].IsEmpty());
}
if (hasFilters()) {
  values[1] = ToV8Traits<IDLSequence<USBDeviceFilter>>::ToV8(script_state, member_filters_);
DCHECK(!values[1].IsEmpty());
}
}

const void* USBDeviceRequestOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> USBDeviceRequestOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void USBDeviceRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "USBDeviceRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("exclusionFilters");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<USBDeviceFilter>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_exclusion_filters_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filters");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<USBDeviceFilter>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_filters_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> USBDeviceRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
