// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_xr_webgl_layer_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"alpha",
"antialias",
"depth",
"framebufferScaleFactor",
"ignoreDepthValues",
"multiview",
"stencil",
};


}  // namespace 

XRWebGLLayerInit* XRWebGLLayerInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  XRWebGLLayerInit* dictionary = MakeGarbageCollected<XRWebGLLayerInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "XRWebGLLayerInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 XRWebGLLayerInit::XRWebGLLayerInit() {
  
}

 XRWebGLLayerInit::XRWebGLLayerInit(v8::Isolate* isolate) {
  
}






































void XRWebGLLayerInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_alpha_);
TraceIfNeeded<bool>::Trace(visitor, member_antialias_);
TraceIfNeeded<bool>::Trace(visitor, member_depth_);
TraceIfNeeded<double>::Trace(visitor, member_framebuffer_scale_factor_);
TraceIfNeeded<bool>::Trace(visitor, member_ignore_depth_values_);
TraceIfNeeded<bool>::Trace(visitor, member_multiview_);
TraceIfNeeded<bool>::Trace(visitor, member_stencil_);
bindings::DictionaryBase::Trace(visitor);
}

void XRWebGLLayerInit::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void XRWebGLLayerInit::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAlpha()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_alpha_);
DCHECK(!values[0].IsEmpty());
}
if (hasAntialias()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_antialias_);
DCHECK(!values[1].IsEmpty());
}
if (hasDepth()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_depth_);
DCHECK(!values[2].IsEmpty());
}
if (hasFramebufferScaleFactor()) {
  values[3] = ToV8Traits<IDLDouble>::ToV8(script_state, member_framebuffer_scale_factor_);
DCHECK(!values[3].IsEmpty());
}
if (hasIgnoreDepthValues()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_ignore_depth_values_);
DCHECK(!values[4].IsEmpty());
}
if (hasMultiview()) {
  values[5] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_multiview_);
DCHECK(!values[5].IsEmpty());
}
if (hasStencil()) {
  values[6] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_stencil_);
DCHECK(!values[6].IsEmpty());
}
}

const void* XRWebGLLayerInit::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> XRWebGLLayerInit::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void XRWebGLLayerInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "XRWebGLLayerInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("alpha");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_alpha_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("antialias");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_antialias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depth");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_depth_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framebufferScaleFactor");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_framebuffer_scale_factor_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ignoreDepthValues");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_ignore_depth_values_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("multiview");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_multiview_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencil");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_stencil_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> XRWebGLLayerInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
